/*
	Copyright 1985, 1986, 1987, 1988, 1989, 1990, 1991 Chris Lewis
		All Rights Reserved

    See the LICENSE file for a full description of restrictions under which
    this software is provided.

	Function:	Main header file - contains some customization
 */

/*	Official Release and Patch level:	*/
#define	T2VERSION	"@(#)PSROFF Copyright 92/01/27 Chris Lewis - R3 PL9"

/*	Configuration parameters:
 */

#undef	BSD		/* Define if you are a V7 or BSD machine */
			/* strchr vs. index etc.... */

#define	ATT		/* Define if you are some sort of SIII or SV system */

#undef	BCOPY		/* Define if you don't have memcpy and friends - eg:
			   oldish BSD systems */

#undef  BCOPYLIB	/* Define if BCOPY is defined and you have */
			/* a bcopy in your library */

#undef	REGSPILL	/* Define if your compiler gives "infinite register
			   spill" in utils/psxlate.c (Xenix III) */
	

/*	The name of a routine that can be called thusly:
	VFPRINTF(stream, format, ap)
	FILE *stream;
	char *format;
	va_list ap;
    (eg: you have varargs.h and you have a routine functionally compatible
    with System V vfprintf.  I think BSD has one too)

    undef if you don't got, and maybe my fakeout will work.
 */

#define VFPRINTF	vfprintf

/* If you have the stand-alone pk2sfp distribution, do not touch
   anything from here on */

/*	Font width file configuration (applicable to CAT troff):

	1) if the /usr/lib/font/ftR file in your original troff
	   installation is 224 bytes long, set HEADERSIZE to 0.
	   Most Xenix.

	2) If the size of /usr/lib/font/ftR is > 224, and your system
	   uses a.out.h headers on executable binaries, HEADERSIZE
	   should be the size of the a.out header.  Usually 32.
	   (Ie: SunOS, VAX/Ultrix)

	3) If the size of /usr/lib/font/ftR is large (around 1K), chances
	   are that your system uses COFF headers on font files.
	   HEADERSIZE should be set to the offset of the data section
	   within /usr/lib/font/ftR.  Which is a bit tricky to find out.
	   However, Apollo DomainOS is the only system I know that has
	   COFF headers.  SR10.3 needs HEADERSIZE set to 304.  Prior
	   DomainOS versions (eg: SR10.2) appear to need 336.

	4) If you are DEC Risc/Ultrix (not VAX/Ultrix) define
	   ASCIIWIDTHS.  HEADERSIZE is irrelevant.

    See the description of HEADERSIZE, and the "HEADERSIZE Calculations"
    section in the TROUBLE document if you have difficulty.  There is
    extensive instructions on how to determine this parameter.  This
    parameter is the most common cause of problems.

    The headers I write will have something in them if HEADERSIZE > 0
    and there's a font file from your original troff distribution in
    /usr/lib/font/ftR (the header and trailer will be copied over).

 */

#define	HEADERSIZE 0	/* size of header in bytes */
#undef	ASCIIWIDTHS	/* For RISC/Ultrix */

/* What do your CAT codes look like?

   If BSDHACK defined, the code to magnify the next lead by 64 replaces the
   codes to set the tilt (tilt used only on 8-font CATs, which most CAT troff
   programs don't support).

   Both FONT8 and BSDHACK code are *untested*.  FONT8 probably does *not*
   work.
 */

#undef	BSDHACK		/* Has magnify lead opcode - untested */
#undef	FONT8		/* 8 Font device - untested */
#define FONT4		/* Normal 4 font device */

			/* define a command for decompressing an argument
			   file to stdout - allows you to compress SFP's.
			   undef if you don't got.  The -d option may be
			   undocumented, but means decompress.  "-dc"
			   is equivalent to zcat.  -dc appears to be
			   in most versions of compress (eg: v3 & v4) */
#define	COMPRESS	"/usr/lbin/compress -dc"

/*	Some postscript printers don't accept control-D as job termination
	(DEC scriptwriters for instance, or LAN-connected printers).  In that
	case, define this macro.  Alternately, if you have a proper printer
	manager that does this sort of stuff, define it too.
	If your printer will take "stop", specify "-S" in psrofflib's
	t2arg, and leave this undefined.
 */
#undef	NOCONTROLD

/*	define if you don't want your Postscript printer talking to you.
	OR, if you're trying to drive xtroff patch level 9 or less. */
#undef	NOCHATTER

/*	The only advantage to commenting-out one of these is to make the
	binary executable of troff2?? smaller.
 */

/*	Basic drivers: */
#define	PS	/* Postscript */
#define	LJ	/* Laserjet - utils programs will not build with this undef'd */
#define	LJ3	/* Laserjet 3 - does LJ + HP-GL/2 for PIC */
#define	DT	/* ditroff */
#define	DIT	/* ditroff *front-end* */

/*	Laserjet driver config: */
#define	PK	/* enable PK font downloading (needs LJ) */

#define	SFP	/* enable SFP incremental font downloading (needs PK).
		   You can still use SFP's without this turned on, but
		   you won't get incremental downloading */

#define	PARTIAL	/* partial (not incremental) font downloading */

#define	INCR	/* enable incremental font downloading (needs PARTIAL) */

#define	MDLF	16	/* Max # downloaded fonts permitted by your laserjet
			   per *page*.  16 is correct for HPLJ+ and most II's.
			   IIP's are 32 I think.  Some newer ones have higher
			   restrictions (don't put this too high even if
			   your printer supports it, you may run out of
			   memory) */

#define	PRELOAD	0	/* set to number of LJ fonts permanently
			   downloaded to printer.  The backend will
			   make sure that you don't go over the number
			   of fonts permitted by the printer */

#define	DEBUG		/* Do you want the debugger in?  If you encounter
			   problems and you want help from me, you'll have
			   to have this turned on */

#define	OPT		/* CAT code reorder and optimizer */

#define	DEFPL  11	/* Default page length (11 inches).
			   DO NOT change unless you absolutely HAVE to.
			   You should only need to change this if you
			   desire your printer to use something different
			   as default.  If so, you'll HAVE to change
			   your macro package to agree on the default - RT
			   owners take note! (the man macros are wrong) */

#define	DEFOFF 0.5	/* Default page offset.  DO NOT change unless you
			   absolutely HAVE to.  You should only need this
			   if: your vendor has buggered your macros to
			   have a different default .po offset (Xenix),
			   and you aren't using the macro adapter
			   libraries that come with psroff (eg: you're
			   using troff2ps directly).  See README/TROUBLE/
			   psroff(1) (-O vs. -rO options) */

#define	DEFYOFF   0	/* Default page vertical offset.  See README/TROUBLE/
			   psroff(1) -Y options too */

#define	INSPECIAL	/* enables ditroff graphics capability */

#define	NSP	256	/* number of \(xx characters. */

#define	NODECMD	"uuname -l" /* command to print on stdout the node name
			   of your machine.  Use hostname on BSD-derived
			   systems that don't have UUCP.  You can always
			   use "echo <nodename>" if necessary */

#define	DTOPT	1	/* undef to turn off ditroff output optimization.
			   Do so only if your ditroff output looks wierd.  If
			   you have to do this, please contact me with the
			   particulars of the problem and your configuration */

#undef LJ3_7BIT		/* define to make repeated vector encoding (HP-GL/2
			   PE command) use 7-bit encoding.  Define this only
			   if driver will be used on a 7-bit serial path.
			   This is rarely helpful, because font downloading
			   needs a 8 bit path */

/*	Edit no more .... */

#define	MAXDLFONTS (MDLF - PRELOAD)	/* # fonts troff2ps can download */

/*	configuration verification */

#if	defined(BSDHACK) && defined(FONT8)
#include	"BSDHACK and FONT8 cannot be defined at the same time"
#endif
#if	defined(FONT4) && defined(FONT8)
#include	"FONT4 and FONT8 cannot be defined at the same time"
#endif

#if	!defined(LJ) && defined(PK)
#include	"Pointless to define PK without LJ"
#endif

#if	!defined(PK) && (defined(INCR) || defined(PARTIAL))
#include	"Pointless to define INCR or PARTIAL without PK"
#endif

#if	defined(INCR) && !defined(PARTIAL)
#include	"Don't support INCR without PARTIAL"
#endif

#if	defined(SFP) && !defined(PK)
#include	"Can't define SFP without PK"
#endif

#if	!defined(LJ) || !defined(PK)
#include	"Sorry, can't compile without LJ and PK (for now)"
#endif

#include <stdio.h>
#include <ctype.h>

#ifdef BSD
#include <strings.h>
#define	strchr	index
#define	strrchr	rindex
#else
#include <string.h>
#endif

#ifdef	BCOPY
#define	memcpy(to, from, len)	bcopy(from, to, len)
#define	clrarray(array, len)	bzero(array, len)
#else
#define	clrarray(array, len)	memset(array, '\0', len)
#endif

#define	ESC	0x80
#define	FLASH	0x00
#define	CONTROL	0x40
#define	LEAD	0x60
#define	SIZE	0x50

#define	DOWN	0
#define	UP	1
#define	LOWER	2
#define	UPPER	3
#define	FORWARD	4
#define	BACKWARD 5

#define	TROFFRESOLUTION	432

#define	SPECIAL		/* define if you want to support special directives */
#define	FORM		/* define if you want the forms facility */

FILE	*diagFile;

#ifdef DEBUG
#define	DBP(x)	if (diagFile) dprintf x
extern dprintf();
#else
#define	DBP(x)
#endif

typedef int(*FUNC)();

#define	FNULL	(FUNC) NULL

struct	troff2befont {
	short	t2b_font;	/* font (troff nomenclature) S=don't change */
	short	t2b_xc;		/* X-shift */
	short	t2b_yc;		/* Y-shift */
	short	t2b_scale;	/* point size scale adjust */
	char 	*t2b_charseq;	/* character sequence - may include PS */
};

struct cattab {
    char *ch_name;
    unsigned char ch_set;
    unsigned char ch_catidx;
    unsigned char ch_wididx;
    unsigned char ch_info;	/* used by some auxiliary programs */
    char *ch_desc;
};

struct backend {
    char	*bename;
    FUNC	beprolog,
		beepilog,
		beputchar,
		bepage,
		befontsel,	/* special function F */
		beoverlay,	/* special function O */
		bepassthru,	/* special function P */
		bexlat,		/* Xlate function */
		bedraw;		/* Ditroff draw emulation routine */
    struct troff2befont
		*bestdfont,	/* standard font translate table */
		*besymfont;	/* symbol font translate table */
};

#define	MAXFONTS	50

#define	USED		01
#define	MOUNTED		02

struct fonttable {
    char *tab[4];
    long flags;
#ifdef	INCR
    struct downmaps *map;
#endif
#ifdef	OPT
    char *widthtable;
#endif
};

/*	Symbolic names for tab entries in fonttable	*/
#define	troffName	tab[0]	/* troff name */
#define	fontName	tab[1]	/* back-end name (if used) */
#define	fontSeq		tab[2]	/* sequence to emit to shift to it
				   lj builtin's mostly */

/*	fontFlags is 16 characters that reflect the state of the font
	at a particular pointsize - mainly for lj */

/*	Use of flags:
	s:	unloaded SFP
	S:	loaded SFP
	p:	unloaded PK
	P:	loaded PK
	n:	non-existant
	b:	builtin.
 */
#define	fontFlags	tab[3]

extern int symidx;		/* index of symbol font */

#define	INTFONTS	10	/* maximum number of builtin fonts */

extern struct fonttable fonttable[MAXFONTS+1];
extern struct fonttable *xlatetable[INTFONTS];
#define	EXTCHUNK	10
extern struct troff2befont *extchars;
extern struct cattab **spctab, **dittab;
extern struct cattab *extidx;
extern int extcount;
extern char *pstrailer;

struct backend *be;
#define	BNULL	(struct backend *) NULL

extern char *skipblanks();

/*	Common Back-end definitions */

#define	N	(unsigned char) (0xff)	/* Use standard font */
#define	S	(unsigned char) (0xfe)	/* Use symbol font */
#define	D	(unsigned char) (0xfd)	/* Draw macro exists - use string directly */
#define	NTC	(unsigned char) (0xfc)	/* No font/Special flag */

#define	NOC	NULL

extern int currentPage;
extern int pageoffset;
extern int pageyoffset;
extern int pagelength;
extern int pagePending;
int dtopt;

#ifdef	OPT
extern char *widthtables;
extern char *widthptr;
extern int optimize;
#endif

extern int lastFont, lastPoints;
extern int lastYPos, lastXPos, specXPos, specYPos;
extern char *progname, *printer, *device;
extern char **prologs;

int metrics;
#ifdef	DIT
int ditroff;
#endif

FILE *libopen();

/*	Encoding format for generating width tables from font files */
/*	Used by pk2ditwid and friends */
struct enctab {
    char *e_name;
    char *e_seq;
    char e_wid;
};

/*	Points in an inch */
#define	POINT	72.27

#define	min(a,b)	((a) < (b) ? (a) : (b))
#define	max(a,b)	((a) > (b) ? (a) : (b))

/* debug flags */
#define	D_CAT	1	/* show cat interpretation machinery */
#define	D_SPEC	2	/* show special directives */
#define	D_CHAR	4	/* optimizer machinery */
#define	D_FONT	8	/* font handling */
#define	D_BEND	0x10	/* backend */
#define	D_PK	0x20	/* PK font handling */
#define	D_VERB	0x40	/* very verbose */
#define	D_FLSH	0x80	/* flush after each fprintf */
#define D_PIC	0x100	/* show pic commands */

extern int debug;

extern char username[];

extern char *mustmalloc();

extern char *version, *shortversion;

#define	MAXPAGE	2000
#ifdef	ALONE
#undef	PARTIAL
#undef	INCR
#endif
