%%STARTSHELL%%
#	Copyright 1985, 1986, 1987, 1988, 1989, 1990, 1991 Chris Lewis
#		All Rights Reserved
#
#    See the LICENSE file for a full description of the restrictions
#    under which this software is provided.
#
#	2.7 91/04/25 Generate extension list of characters for troff2ps.
if [ $# != 1 ]
then
    echo "usage: genext <ditroff font width directory>" >&2
    exit 1
fi
widthdir=$1
if [ ! -d $widthdir ]
then
    echo "genext: $widthdir not a directory"
    exit 1
fi
a=`ls $widthdir/? 2> /dev/null`
if [ -n "$a" ]
then
    files=$a
fi
a=`ls $widthdir/?? 2> /dev/null`
if [ -n "$a" ]
then
    files="$files $a"
fi
if [ -z "$files" ]
then
    echo "genext: No width tables in $widthdir"
    exit 0
fi

awk '
    BEGIN {
	state = 0
	seen["BLOT"] = 1
    }

$1 ~ /^{"/ {
	i = length($1) - 3 - 1
	ch = substr($1, 3, i)
	if (ch ~ /^\\/)
	    ch = substr(ch, 2)
	catcodes[ch] = 1
	next
    }

$1 ~ /^name/ {
	curfont = $2
	next
    }

/charset/ {
	incharset = 1
    }

NF == 2 && $2 == "\"" {
	if (catcodes[$1] || $1 == "\\|" || $1 == "\\^" || $1 == "---")
	    next
	if (seen[$1]) {
	    if (seen[$1] != code)
		printf "Duplicate %s, but different codes! (%s/%s)\n", \
		    $1, seen[$1], code > "/tmp/errors"
	    next
	}

	seen[$1] = code
	if (curfont == "S")
	    flag = "S"
	else if (curfont ~ /S[0-9]/)
	    flag = 4
	else
	    flag = "N"

	printf("%s	%s	%s\n", $1, flag, code);
    }
	
/faked/	{ next }
NF >= 4 && $2 ~ /^[0-9,]*$/ && $3 ~ /^[0-9]*$/	{
	if (!incharset)
	    next
	if (catcodes[$1] || $1 == "\\|" || $1 == "\\^" || $1 == "---")
	    next

	code = $4
	if (length(code) > 3)
	    code = substr(code, length(code) - 2, 3)

	while(length(code) < 3) {
	    code = "0" code
	}

	code = "\\" code
	if (seen[$1]) {
	    if (seen[$1] != code)
		printf "Duplicate %s, but different codes! (%s/%s)\n", \
		    $1, seen[$1], code > "/tmp/errors"
	    next
	}

	seen[$1] = code

	if (curfont == "S")
	    flag = "S"
	else if (curfont ~ /S[0-9]/)
	    flag = 4
	else
	    flag = "N"
	printf("%s	%s	%s\n", $1, flag, code)
    }

' ../utils/ljtab.c $files
