%%STARTSHELL%%
#	Copyright 1985, 1986, 1987, 1988, 1989, 1990, 1991 Chris Lewis
#		All Rights Reserved
#
#    See the LICENSE file for a full description of the restrictions
#    under which this software is provided.
#
#@(#)gfnttab.sh 2.8 91/04/25
#	Set this to something non-null in the Makefile if you need
#	a.out.h/COFF headers on your width files, and the COFF/HEADERSIZE
#	defines cause dit2catwid to generate width tables that
#	troff screams about.
compile=%%COMPILE%%
if [ "$1" = "-e" ]
then
    ext=-e
    shift
fi
rc=1
dir=$1
install=$2
curdir=`pwd`
fontdir=%%FONTDIR%%
trap "echo GFNTTAB failed ; rm -f /tmp/S ; exit \$rc" 0 1 2 3 15
if [ -z "$dir" ]
then
    echo "Missing font directory argument"
    exit
fi
echo "GFNTTAB: Processing font directory $dir"
if [ -n "$install" ]
then
    ffile=$curdir/$install.fonts.new
else
    ffile=`basename $dir | sed -e 's/^width\(.*\)$/\1/'`
    ffile=$curdir/$ffile.fonts.new
fi
rm -f $ffile
if [ ! -d $dir ]
then
    echo "No $dir directory"
    exit
fi
cd $dir
rm -f /tmp/S
if [ ! -r R ]
then
    if [ -r TR ]
    then
	R=TR
    else
	echo "Creating Dummy R font width table"
	touch R
    fi
else
    R=R
fi
if [ -r S ]
then
    cp S /tmp/S
    chmod 644 /tmp/S
    for i in S1 S2 S3 S4 S5 S6 S7 S8 S9 ST SI
    do
	if [ -r $i ]
	then
	    sed -e '1,/charset/d' $i >> /tmp/S
	fi
    done
else
    echo "WARNING: no symbol font!"
    > /tmp/S
fi
DESC=DESC
if [ -r $DESC ]
then
    res=`sed -n -e 's/^[ 	]*res[ 	][ 	]*\([0-9][0-9]*\).*/\1/p' $DESC`
    if [ -z "$res" ]
    then
	echo "WARNING: no 'res' command in DESC - assuming 300"
	res="-r 300"
    else
	ss=`sed -n \
	    -e 's/^[ 	]*sizescale[ 	][ 	]*\([0-9][0-9]*\).*/\1/p' $DESC`
	if [ -n "$ss" ]
	then
	    echo "INFO: Found sizescale of $ss (probably groff)"
	    res=`expr $res / $ss`
	fi
	res="-r $res"
    fi
    unit=`sed -n -e 's/^[ 	]*unitwidth[ 	][ 	]*\([0-9][0-9]*\).*/\1/p' $DESC`
    if [ -n "$unit" ]
    then
	res="$res -u $unit"
    else
	echo "WARNING: no 'unitwidth' command in DESC - assuming 10"
	res="$res -u 10"
    fi
else
    echo "WARNING: no DESC file in $dir - assuming 'res 300 unitwidth 10'"
    res="-r 300 -u 10"
fi
echo "Using $res parameters"
for i in [A-Z]*
do
    case $i in
	??) ;;
	?) ;;
	*) continue ;;
    esac
    trc=0
    case $i in
	S[0-n] | ST | SI )
	    ;;
	*)
	    Cline=`sed -e '1q' $i | sed -e 's/^#[ 	]*//'`
	    echo "$i	$Cline" >> $ffile
	    ;;
    esac
    case $i in
	S)
	    args="-s $R /tmp/S"
	    ;;
	SU)
	    args="-s $R $i"
	    ;;
	S[0-9] | SI | ST )
	    continue
	    ;;
	*)
	    args="/tmp/S $i"
	    ;;
    esac
    echo "GFNTTAB: processing font $i ($Cline)"
    if [ -n "$compile" ]
    then
	$curdir/dit2catwid $ext $res -c $args ft${i}.c
	if [ $? != 0 ]
	then
	    trc=1
	else
	    cc -c ft${i}.c
	    trc=$?
	    mv ft${i}.o ft${i}
	fi
    else
	$curdir/dit2catwid $ext $res $args ft${i}
	trc=$?
    fi
    chmod 644 ft${i} > /dev/null 2>&1
    if [ $trc != 0 ]
    then
	rc=2
    fi
done
rm -f /tmp/S
if [ $rc -gt 1 ]
then
    exit
fi
if [ -s "$ffile" ]
then
    ed - $ffile <<\!
0a
DUM
DUM
DUM
DUM
.
g/^R	/m0
g/^I	/m1
g/^B	/m2
g/^S	/m3
4a
S2	BracketFont
.
g/^DUM/d
w
q
!
fi
if [ $? != 0 ]
then
    exit
fi
if [ -n "$install" ]
then
    if [ ! -d $fontdir/$install ]
    then
	mkdir $fontdir/$install
    fi
    mv ft* $fontdir/$install
    if [ $? != 0 ]
    then
	exit
    fi
fi
trap '' 0
rc=0
exit 0
